summaryrefslogtreecommitdiffstats
path: root/academic/NWChem
diff options
context:
space:
mode:
author William PC <w_calandrini[at]hotmail[dot]com>2022-12-08 23:23:17 +0000
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2022-12-10 07:43:12 +0700
commit4e895261acad56cfe5eb0f3bb7286850465a31ee (patch)
treeee1f28ef8be759b4d3cc0d15d25751a2a29c20e8 /academic/NWChem
parent75843670d0cfa2526f078f2861d74b668894d014 (diff)
downloadslackbuilds-4e895261acad56cfe5eb0f3bb7286850465a31ee.tar.gz
slackbuilds-4e895261acad56cfe5eb0f3bb7286850465a31ee.tar.xz
academic/NWChem: Added (High-Performance Computational Chemistry)
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'academic/NWChem')
-rw-r--r--academic/NWChem/NWChem.SlackBuild170
-rw-r--r--academic/NWChem/NWChem.info10
-rw-r--r--academic/NWChem/README15
-rw-r--r--academic/NWChem/slack-desc19
4 files changed, 214 insertions, 0 deletions
diff --git a/academic/NWChem/NWChem.SlackBuild b/academic/NWChem/NWChem.SlackBuild
new file mode 100644
index 0000000000..ac62916771
--- /dev/null
+++ b/academic/NWChem/NWChem.SlackBuild
@@ -0,0 +1,170 @@
+#!/bin/bash
+
+# Slackware build script for NWChem
+
+# Copyright 2022 William PC - Seattle, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=NWChem
+VERSION=${VERSION:-7.0.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+SRCNAM="nwchem-$VERSION-release.revision-b9985dfa-srconly.2020-10-12"
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf nwchem-$VERSION
+tar xvf $CWD/$SRCNAM.tar.bz2
+cd nwchem-$VERSION
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+
+case "$ARCH" in
+ i?86) NWCHEM_ARCH=LINUX ;;
+ armv7l) NWCHEM_ARCH=LINUX ;;
+ aarch64) NWCHEM_ARCH=LINUX64 ;;
+ *) NWCHEM_ARCH=LINUX64 ;;
+esac
+
+if [ "${BLAS:-no}" == "yes" ]; then
+ BLASOPT="-lblas"
+ LAPACK_LIB="/usr/lib${LIBDIRSUFFIX}/liblapack.so"
+ INTBLAS=n
+else
+ INTBLAS=y
+fi
+
+# whatever set always try to build with MPI,
+# actually it checks if the BUILD_MPI is defined or not
+# the version 7.0.2 doesn't support buildings without MPI
+if [ "${MPI:-no}" == "yes" ]; then
+ BUILD_MPI="y"
+else
+ BUILD_MPI="n"
+fi
+
+if [ "${PYTHON:-no}" == "yes" ]; then
+ OPT_MODULE="python"
+fi
+
+# fix for "integer expression expected"
+sed -i 's/ $(GNUMAJOR) / "$(GNUMAJOR)" /g' src/config/makefile.h
+sed -i 's/ $(GNUMINOR) / "$(GNUMINOR)" /g' src/config/makefile.h
+sed -i 's/\(-eq\|-gt\|-ge\) \([0-9]*\)/\1 "\2"/g' src/config/makefile.h
+
+cd src
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+NWCHEM_TOP=$(pwd)/.. \
+NWCHEM_TARGET=$NWCHEM_ARCH \
+NWCHEM_MODULES="all $OPT_MODULE" \
+USE_MPI=$BUILD_MPI \
+USE_INTERNALBLAS=$INTBLAS \
+BLASOPT=$BLASOPT \
+LAPACK_LIB="$LAPACK_LIB" \
+make
+cd ..
+
+# perform installation
+install -d $PKG/usr/bin
+install -m 0755 bin/$NWCHEM_ARCH/nwchem $PKG/usr/bin
+
+mkdir -p $PKG/usr/share/$PKGNAM-$VERSION
+cp -ar src/basis/libraries $PKG/usr/share/$PRGNAM-$VERSION
+cp -ar src/data $PKG/usr/share/$PRGNAM-$VERSION
+cp -ar src/nwpw/libraryps $PKG/usr/share/$PRGNAM-$VERSION
+
+cat <<EOF >> $PKG/usr/share/$PRGNAM-$VERSION/nwchemrc.default
+nwchem_basis_library /usr/share/$PRGNAM-$VERSION/data/libraries/
+nwchem_nwpw_library /usr/share/$PRGNAM-$VERSION/data/libraryps/
+ffield amber
+amber_1 /usr/share/$PRGNAM-$VERSION/data/amber_s/
+amber_2 /usr/share/$PRGNAM-$VERSION/data/amber_q/
+amber_3 /usr/share/$PRGNAM-$VERSION/data/amber_x/
+amber_4 /usr/share/$PRGNAM-$VERSION/data/amber_u/
+spce /usr/share/$PRGNAM-$VERSION/data/solvents/spce.rst
+charmm_s /usr/share/$PRGNAM-$VERSION/data/charmm_s/
+charmm_x /usr/share/$PRGNAM-$VERSION/data/charmm_x/
+EOF
+
+
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG -depth -type d -empty -delete || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/academic/NWChem/NWChem.info b/academic/NWChem/NWChem.info
new file mode 100644
index 0000000000..4f2effb9d9
--- /dev/null
+++ b/academic/NWChem/NWChem.info
@@ -0,0 +1,10 @@
+PRGNAM="NWChem"
+VERSION="7.0.2"
+HOMEPAGE="https://www.nwchem-sw.org"
+DOWNLOAD="https://github.com/nwchemgit/nwchem/releases/download/v7.0.2-release/nwchem-7.0.2-release.revision-b9985dfa-srconly.2020-10-12.tar.bz2"
+MD5SUM="b39f42eeacd7e984eee8b7ebc3dfe9f8"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="mpich"
+MAINTAINER="William PC"
+EMAIL="w_calandrini[at]hotmail[dot]com"
diff --git a/academic/NWChem/README b/academic/NWChem/README
new file mode 100644
index 0000000000..59b0933021
--- /dev/null
+++ b/academic/NWChem/README
@@ -0,0 +1,15 @@
+ NWChem aims to provide its users with computational chemistry tools
+that are scalable both in their ability to treat large scientific
+computational chemistry problems efficiently, and in their use of
+available parallel computing resources from high-performance parallel
+supercomputers to conventional workstation clusters.
+
+
+ The default configuration file is at:
+ /usr/share/NWChem-VERSION/nwchemrc.default copy it to your working
+directory.
+
+ If you want to install the Python module set the environment
+variable PYTHON=yes.
+ By default it uses a internal blas library, if you want to use
+another blas library please set BLAS=yes and install blas and lapack.
diff --git a/academic/NWChem/slack-desc b/academic/NWChem/slack-desc
new file mode 100644
index 0000000000..b1b7a375b8
--- /dev/null
+++ b/academic/NWChem/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+NWChem: NWChem (Open Source High-Performance Computational Chemistry)
+NWChem:
+NWChem:
+NWChem: NWChem aims to provide its users with computational chemistry tools
+NWChem: that are scalable both in their ability to treat large scientific
+NWChem: computational chemistry problems efficiently, and in their use of
+NWChem: available parallel computing resources from high-performance parallel
+NWChem: supercomputers to conventional workstation clusters.
+NWChem:
+NWChem:
+NWChem: